;Chess85 by JL
; jayell64@aol.com
;Hope this source code is readable!

 #include "usgard.h"

 .org 0
 .db "Chess85Lite by JL",0

GameBoard       =TEXT_MEM
Selecty         =TEXT_MEM+64
Selectx         =TEXT_MEM+65
Turn    =TEXT_MEM+66
Undoy1	=TEXT_MEM+67
Undox1	=TEXT_MEM+68
Undoy2	=TEXT_MEM+69
Undox2	=TEXT_MEM+70
UndoCap	=TEXT_MEM+71

BoardSetup:     
 set 1,(IY+0D)
 call CLEARTEXT
 call &DispPieces
DispStart:      ;now to display some text
 ld hl,&Intro   ;where the text is
 xor a          ;start at row 0 (really row 1)
DispAllText:
 ld d,$0B       ;load column into d (11,really 12)
 ld e,a         ;load a as the row
 ld ($800C),de  ;necessary input
 call D_ZT_STR  ;now points to next string to be displayed
 inc a                  ;\
 cp 6                   ; >increase a,check if 6
 jr nz,DispAllText      ;/
WaitKey1:
 call GET_KEY
 cp K_F2
 jr z,NewGame
 cp K_F1
 jr z,LoadGame
 cp K_EXIT
 call z,OTH_EXIT
 jr WaitKey1
NewGame:
 ld hl,&NewBoard        ;loads a new board into the playing board
 xor a
 jr LoadBoard
LoadGame:
 ld a,(&SaveTurn)
 ld hl,&SaveGame        ;loads a previously saved game
LoadBoard:
 ld bc,0
 ld (Selecty),bc
 ld (Undoy1),bc
 ld (Turn),a
 ld a,%100001
 ld (UndoCap),a
 ld bc,64
 ld de,GameBoard
 ldir       ;transfers whatever's at hl into de (the board)

Cursor:
 ld hl,$FC00
 ld de,$0101    ;d=y coordinate (1-8) of cursor,e=x coordinate (1-8)
Cursor2:
 call &DispPieces
CursorBlink:
 call &ChangeSq ;xor every bit in square at hl
WaitKey2:
 push hl        ;save hl,since GET_KEY changes it
 call GET_KEY
 pop hl
 or a           ;->if a isn't zero,a key was pressed,and so go check which key
 jr nz,CheckKey ;/
 jr WaitKey2
CheckKey:
 call &ChangeSq
 cp K_F2
 jr z,NewGame
 cp K_F1
 jr z,LoadGame
 cp K_F3
 jr z,GoSave
 cp K_DEL
 jr z,GoUndo
 cp K_DOWN
 jr z,GoDown
 cp K_UP
 jp z,&GoUp
 cp K_LEFT
 jp z,&GoLeft
 cp K_RIGHT
 jp z,&GoRight
 cp K_SECOND
 jp z,&GoSecond
 cp K_EXIT
 call z,OTH_EXIT
 jr CursorBlink
GoSave:         ;saves game into space near end of program
 push hl
 push de
 ld a,(Turn)
 ld hl,&SaveTurn
 ld (hl),a
 ld hl,GameBoard
 ld de,&SaveGame
 ld bc,64
 ldir
 ld hl,&SaveGameStr
 ld de,$0B06
 ld ($800C),de
 call D_ZT_STR
 call OTH_PAUSE
 ld hl,&BlankStr
 ld ($800C),de
 call D_ZT_STR
 pop de
 pop hl
 jr CursorBlink
GoUndo:
 ld a,(Undoy1)
 or a
 jr z,CursorBlink
 push de
 push hl
 ld de,(Undoy2)
 call &FindPiece
 push af
 call &FindPieceAdd
 ld a,(UndoCap)
 ld (hl),a
 pop af
 ld de,(Undoy1)
 call &FindPieceAdd
 ld (hl),a
 ld a,(Turn)
 xor %00000001
 ld (Turn),a
 xor a
 ld (Undoy1),a
 pop hl
 pop de
 jp &Cursor2
GoDown:         ;moves cursor down,affects hl(address of cursor) and de (x/y coordinates)
 ld a,7
 cp d
 jp c,&CursorBlink
 ld bc,$80
 add hl,bc
 inc d
 jp &CursorBlink
GoUp:           ;moves cursor up;opposite of GoDown
 ld a,1
 cp d
 jp nc,&CursorBlink
 ld bc,$80
 or a
 sbc hl,bc
 dec d
 jp &CursorBlink
GoLeft:         ;moves cursor left
 ld a,1
 cp e
 jp nc,&CursorBlink
 dec hl
 dec e
 jp &CursorBlink
GoRight:        ;moves cursor right
 ld a,7
 cp e
 jp c,&CursorBlink
 inc hl
 inc e
 jp &CursorBlink
DeSelect:       ;deselects square if second pushed
 ld bc,0
 ld (Selecty),bc
 call &BorderSquare
 jp &CursorBlink
SelectSq:       ;selects square if second pushed
 call &BorderSquare     ;border square
 call &FindPiece
 or a
 jr z,DeSelect
 cp %00100000 
 ld c,0
 call nc,&Switch_c
 ld a,(Turn)
 cp c
 jr nz,DeSelect
 ld (Selecty),de
 jp &CursorBlink
GoSecond:       ;if second pushed...
 push hl
 ld hl,(Selecty)        ;\
 call CP_HL_DE          ; >check if chosen square is preselected square w/o losing hl and de
 pop hl                 ;/
 jr z,DeSelect          ;if so,deselect square
 ld a,(Selectx)         ;->see you've if already selected a square;if not,select current square
 or a                   ;/
 jr z,SelectSq          ;if not,select the square you're on if it's you're piece
 call &FindPiece
 or a
 jr z,OKMove1
 cp %00100000
 ld c,0
 call nc,&Switch_c
 ld a,(Turn)
 cp c
 jp z,&CursorBlink
OKMove1:

 push hl
 ld (Undoy2),de
 call &FindPiece
 ld (UndoCap),a
 push de
 ld de,(Selecty)
 ld (Undoy1),de
 call &FindPiece
 call &FindPieceAdd
 ld (hl),0
 pop de
 call &FindPieceAdd
 ld (hl),a
 pop hl
 ld a,(Turn)
 xor %00000001
 ld (Turn),a
 ld bc,0
 ld (Selecty),bc
 jp &Cursor2

BorderSquare:
 push hl
 call &BS2
 ld bc,$70
 add hl,bc
 call &BS2
 pop hl
 ret
BS2: 
 ld a,(hl)
 xor %10000001
 ld (hl),a
 ret
 
ChangeSq:       ;xor's every bit in specified 8*8 square
 push de        ;hl=address of square (in upper right) in VideoMem
 push hl
 push af
 ld b,8
 ld de,$10
CS2:
 ld a,(hl)
 xor %11111111
 ld (hl),a
 add hl,de
 djnz CS2
 pop af
 pop hl
 pop de
 ret

FindPieceAdd:
 push de
 dec d
 dec e
 ld l,d
 ld h,0
 add hl,hl
 add hl,hl
 add hl,hl
 ld bc,GameBoard
 add hl,bc
 ld b,0
 ld c,e
 add hl,bc
 pop de
 ret

FindPiece:      ;finds piece on board at (e,d) and returns with value in a
 push hl
 call &FindPieceAdd
 ld a,(hl)
 pop hl
 ret

DispPieces:     ;Puts pieces where needed
 push hl
 push de
 ld b,8         ;8 rows
 ld hl,GameBoard
 ld de,$FC00
 ld c,0         ;c used same way in PutImage;if no piece on current square,0=white,1=black
DrawPieces:
 call &Switch_c
 push bc
 ld b,8         ;8 columns
DrawPieces1:
 call &Switch_c
 ld a,(hl)      ;take byte from playing board
 push hl
 push af
 and %00011111  ;take out color
 cp %000001     ; | determine what piece is in a
 jr z,DrawCastle; |
 cp %000010     ;\~/
 jr z,DrawBishop; '
 cp %000011
 jr z,DrawQueen
 cp %000100
 jr z,DrawHorse
 cp %001000
 jr z,DrawKing
 cp %010000
 jr z,DrawPawn
DrawSquare:
 bit 0,c        ;check if c=1
 pop af
 call nz,&DrawBlack     ;if c=1,flag bit 5 in a to let PutImage know to change all bits in &square
 push af
 ld hl,&square
 jr DrawPieces2
DrawBlack:
 or %00100000
 ret
DrawPieces2:
 pop af
 push bc
 ld c,0                 ;\
 bit 5,a                ; >determine color for PutImage
 call z,&Switch_c       ;/
 call &PutImage
 pop bc
 pop hl
 inc hl
 inc de
 djnz DrawPieces1
 ex de,hl       ;-\
 ld bc,$0078    ;  >move to next row ($78+8=8*$10=$80)
 add hl,bc      ; /
 ex de,hl       ;/
 pop bc
 djnz DrawPieces
 pop de
 pop hl
 ret
DrawCastle:
 ld hl,&castle
 jr DrawPieces2
DrawBishop:
 ld hl,&bishop
 jr DrawPieces2
DrawQueen:
 ld hl,&queen
 jr DrawPieces2
DrawHorse:
 ld hl,&horse
 jr DrawPieces2
DrawKing:
 ld hl,&king
 jr DrawPieces2
DrawPawn:
 ld hl,&pawn
 jr DrawPieces2

PutImage:       ;input: hl      address of sprite
 push hl        ;       de      destination address
 push bc        ;       c       for chess purposes only,0=white & 1=black
 push de
 ld b,8         ;8 rows to print
PI_NewRow
 ld a,(hl)      ;this should look familiar if you've used Jimmy's routine,but I had to modify it to fit my needs of xor %11111111-ing certain sprites
 inc hl         ;ready for next time around
 bit 0,c        ;checks if c is 0
 call nz,&Switch2W       ;if so,change all bits in a
 ld (de),a      ;load a into VideoMem
 push bc
 ld bc,$10      ;-\
 ex de,hl       ;  >go to next row of VideoMem
 add hl,bc      ; /
 ex de,hl       ;/
 pop bc
 djnz PI_NewRow
 pop de
 pop bc
 pop hl
 ret

Switch2W:
 xor %11111111
 ret

Switch_c:
 ld a,c
 xor %00000001
 ld c,a
 ret

castle:
 .db %11010110
 .db %11111110
 .db %01111100
 .db %01111100
 .db %01111100
 .db %11111110
 .db %11111110
 .db %00000000

horse:
 .db %00110000
 .db %01111110
 .db %10111110
 .db %01111000
 .db %10111000
 .db %01111100
 .db %11111110
 .db %00000000

bishop:
 .db %00010000
 .db %00111000
 .db %00111000
 .db %00111000
 .db %00010000
 .db %01111100
 .db %11111110
 .db %00000000

queen:
 .db %01010100
 .db %01111100
 .db %00111000
 .db %00010000
 .db %00111000
 .db %01111100
 .db %11111110
 .db %00000000

;king:
; .db %10010010
; .db %11111110
; .db %11111110
; .db %00111000
; .db %00111000
; .db %01111100
; .db %11111110
; .db %00000000
king:
 .db %00101000
 .db %01000100
 .db %01101100
 .db %00101000
 .db %00010000
 .db %01111100
 .db %11111110
 .db %00000000

pawn:
 .db %00000000
 .db %00111000
 .db %00111000
 .db %00111000
 .db %00010000
 .db %01111100
 .db %11111110
 .db %00000000

square:
 .db %11111111
 .db %11111111
 .db %11111111
 .db %11111111
 .db %11111111
 .db %11111111
 .db %11111111
 .db %11111111

Intro:
 .db "----------",0
 .db "Chess85L",0
 .db " by JL",0
 .db " jayell64",0
 .db "  @aol.com",0
 .db "----------",0
SaveGameStr:
 .db "Saved!",0
BlankStr:
 .db "      ",0

SaveGame:       ;Saves Position of Board (Code: %[White=0;Black=1][Pawn=1][King=1][Horse=1][Diagonal Movement(Bishop/Queen)=1][Horizontal/Vertical Movement (Castle/Queen)=1]
 .db %100001,%100100,%100010,%100011,%101000,%100010,%100100,%100001
 .db %110000,%110000,%110000,%110000,%110000,%110000,%110000,%110000
 .db 0,0,0,0,0,0,0,0
 .db 0,0,0,0,0,0,0,0
 .db 0,0,0,0,0,0,0,0
 .db 0,0,0,0,0,0,0,0
 .db %010000,%010000,%010000,%010000,%010000,%010000,%010000,%010000
 .db %000001,%000100,%000010,%000011,%001000,%000010,%000100,%000001

SaveTurn:
 .db 0

NewBoard:
 .db %100001,%100100,%100010,%100011,%101000,%100010,%100100,%100001
 .db %110000,%110000,%110000,%110000,%110000,%110000,%110000,%110000
 .db 0,0,0,0,0,0,0,0
 .db 0,0,0,0,0,0,0,0
 .db 0,0,0,0,0,0,0,0
 .db 0,0,0,0,0,0,0,0
 .db %010000,%010000,%010000,%010000,%010000,%010000,%010000,%010000
 .db %000001,%000100,%000010,%000011,%001000,%000010,%000100,%000001

.end
